import{s as Ce,n as Me,o as ye}from"../chunks/scheduler.8c3d61f6.js";import{S as Le,i as Se,g as a,s as r,r as u,A as we,h as d,f as t,c as i,j as E,u as m,x as N,k as q,y as n,a as l,v as f,d as h,t as g,w as _}from"../chunks/index.589a98e8.js";import{D as R}from"../chunks/Docstring.27406313.js";import{H as me,E as Te}from"../chunks/EditOnGithub.e5a8d9cb.js";function De(fe){let p,U,A,G,C,j,M,J,y,he=`Multistep and onestep scheduler (Algorithm 3) introduced alongside latent consistency models in the paper <a href="https://arxiv.org/abs/2310.04378" rel="nofollow">Latent Consistency Models: Synthesizing High-Resolution Images with Few-Step Inference</a> by Simian Luo, Yiqin Tan, Longbo Huang, Jian Li, and Hang Zhao.
This scheduler should be able to generate good samples from <a href="/docs/diffusers/main/en/api/pipelines/latent_consistency_models#diffusers.LatentConsistencyModelPipeline">LatentConsistencyModelPipeline</a> in 1-8 steps.`,Y,L,Z,s,S,se,H,ge=`<code>LCMScheduler</code> extends the denoising procedure introduced in denoising diffusion probabilistic models (DDPMs) with
non-Markovian guidance.`,oe,O,_e=`This model inherits from <a href="/docs/diffusers/main/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a> and <a href="/docs/diffusers/main/en/api/configuration#diffusers.ConfigMixin">ConfigMixin</a>. <a href="/docs/diffusers/main/en/api/configuration#diffusers.ConfigMixin">~ConfigMixin</a> takes care of storing all config
attributes that are passed in the scheduler’s <code>__init__</code> function, such as <code>num_train_timesteps</code>. They can be
accessed via <code>scheduler.config.num_train_timesteps</code>. <a href="/docs/diffusers/main/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a> provides general loading and saving
functionality via the <a href="/docs/diffusers/main/en/api/schedulers/overview#diffusers.SchedulerMixin.save_pretrained">SchedulerMixin.save_pretrained()</a> and <a href="/docs/diffusers/main/en/api/schedulers/overview#diffusers.SchedulerMixin.from_pretrained">from_pretrained()</a> functions.`,re,b,w,ie,k,be=`Ensures interchangeability with schedulers that need to scale the denoising model input depending on the
current timestep.`,ae,v,T,de,V,ve="Sets the begin index for the scheduler. This function should be run from pipeline before the inference.",ce,x,D,le,z,xe="Sets the discrete timesteps used for the diffusion chain (to be run before inference).",pe,$,P,ue,F,$e=`Predict the sample from the previous timestep by reversing the SDE. This function propagates the diffusion
process from the learned model outputs (most often the predicted noise).`,B,I,K,W,Q;return C=new me({props:{title:"Latent Consistency Model Multistep Scheduler",local:"latent-consistency-model-multistep-scheduler",headingTag:"h1"}}),M=new me({props:{title:"Overview",local:"overview",headingTag:"h2"}}),L=new me({props:{title:"LCMScheduler",local:"diffusers.LCMScheduler",headingTag:"h2"}}),S=new R({props:{name:"class diffusers.LCMScheduler",anchor:"diffusers.LCMScheduler",parameters:[{name:"num_train_timesteps",val:": int = 1000"},{name:"beta_start",val:": float = 0.00085"},{name:"beta_end",val:": float = 0.012"},{name:"beta_schedule",val:": str = 'scaled_linear'"},{name:"trained_betas",val:": Union = None"},{name:"original_inference_steps",val:": int = 50"},{name:"clip_sample",val:": bool = False"},{name:"clip_sample_range",val:": float = 1.0"},{name:"set_alpha_to_one",val:": bool = True"},{name:"steps_offset",val:": int = 0"},{name:"prediction_type",val:": str = 'epsilon'"},{name:"thresholding",val:": bool = False"},{name:"dynamic_thresholding_ratio",val:": float = 0.995"},{name:"sample_max_value",val:": float = 1.0"},{name:"timestep_spacing",val:": str = 'leading'"},{name:"timestep_scaling",val:": float = 10.0"},{name:"rescale_betas_zero_snr",val:": bool = False"}],parametersDescription:[{anchor:"diffusers.LCMScheduler.num_train_timesteps",description:`<strong>num_train_timesteps</strong> (<code>int</code>, defaults to 1000) &#x2014;
The number of diffusion steps to train the model.`,name:"num_train_timesteps"},{anchor:"diffusers.LCMScheduler.beta_start",description:`<strong>beta_start</strong> (<code>float</code>, defaults to 0.0001) &#x2014;
The starting <code>beta</code> value of inference.`,name:"beta_start"},{anchor:"diffusers.LCMScheduler.beta_end",description:`<strong>beta_end</strong> (<code>float</code>, defaults to 0.02) &#x2014;
The final <code>beta</code> value.`,name:"beta_end"},{anchor:"diffusers.LCMScheduler.beta_schedule",description:`<strong>beta_schedule</strong> (<code>str</code>, defaults to <code>&quot;linear&quot;</code>) &#x2014;
The beta schedule, a mapping from a beta range to a sequence of betas for stepping the model. Choose from
<code>linear</code>, <code>scaled_linear</code>, or <code>squaredcos_cap_v2</code>.`,name:"beta_schedule"},{anchor:"diffusers.LCMScheduler.trained_betas",description:`<strong>trained_betas</strong> (<code>np.ndarray</code>, <em>optional</em>) &#x2014;
Pass an array of betas directly to the constructor to bypass <code>beta_start</code> and <code>beta_end</code>.`,name:"trained_betas"},{anchor:"diffusers.LCMScheduler.original_inference_steps",description:`<strong>original_inference_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 50) &#x2014;
The default number of inference steps used to generate a linearly-spaced timestep schedule, from which we
will ultimately take <code>num_inference_steps</code> evenly spaced timesteps to form the final timestep schedule.`,name:"original_inference_steps"},{anchor:"diffusers.LCMScheduler.clip_sample",description:`<strong>clip_sample</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Clip the predicted sample for numerical stability.`,name:"clip_sample"},{anchor:"diffusers.LCMScheduler.clip_sample_range",description:`<strong>clip_sample_range</strong> (<code>float</code>, defaults to 1.0) &#x2014;
The maximum magnitude for sample clipping. Valid only when <code>clip_sample=True</code>.`,name:"clip_sample_range"},{anchor:"diffusers.LCMScheduler.set_alpha_to_one",description:`<strong>set_alpha_to_one</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Each diffusion step uses the alphas product value at that step and at the previous one. For the final step
there is no previous alpha. When this option is <code>True</code> the previous alpha product is fixed to <code>1</code>,
otherwise it uses the alpha value at step 0.`,name:"set_alpha_to_one"},{anchor:"diffusers.LCMScheduler.steps_offset",description:`<strong>steps_offset</strong> (<code>int</code>, defaults to 0) &#x2014;
An offset added to the inference steps, as required by some model families.`,name:"steps_offset"},{anchor:"diffusers.LCMScheduler.prediction_type",description:`<strong>prediction_type</strong> (<code>str</code>, defaults to <code>epsilon</code>, <em>optional</em>) &#x2014;
Prediction type of the scheduler function; can be <code>epsilon</code> (predicts the noise of the diffusion process),
<code>sample</code> (directly predicts the noisy sample<code>) or </code>v_prediction\` (see section 2.4 of <a href="https://imagen.research.google/video/paper.pdf" rel="nofollow">Imagen
Video</a> paper).`,name:"prediction_type"},{anchor:"diffusers.LCMScheduler.thresholding",description:`<strong>thresholding</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to use the &#x201C;dynamic thresholding&#x201D; method. This is unsuitable for latent-space diffusion models such
as Stable Diffusion.`,name:"thresholding"},{anchor:"diffusers.LCMScheduler.dynamic_thresholding_ratio",description:`<strong>dynamic_thresholding_ratio</strong> (<code>float</code>, defaults to 0.995) &#x2014;
The ratio for the dynamic thresholding method. Valid only when <code>thresholding=True</code>.`,name:"dynamic_thresholding_ratio"},{anchor:"diffusers.LCMScheduler.sample_max_value",description:`<strong>sample_max_value</strong> (<code>float</code>, defaults to 1.0) &#x2014;
The threshold value for dynamic thresholding. Valid only when <code>thresholding=True</code>.`,name:"sample_max_value"},{anchor:"diffusers.LCMScheduler.timestep_spacing",description:`<strong>timestep_spacing</strong> (<code>str</code>, defaults to <code>&quot;leading&quot;</code>) &#x2014;
The way the timesteps should be scaled. Refer to Table 2 of the <a href="https://huggingface.co/papers/2305.08891" rel="nofollow">Common Diffusion Noise Schedules and
Sample Steps are Flawed</a> for more information.`,name:"timestep_spacing"},{anchor:"diffusers.LCMScheduler.timestep_scaling",description:`<strong>timestep_scaling</strong> (<code>float</code>, defaults to 10.0) &#x2014;
The factor the timesteps will be multiplied by when calculating the consistency model boundary conditions
<code>c_skip</code> and <code>c_out</code>. Increasing this will decrease the approximation error (although the approximation
error at the default of <code>10.0</code> is already pretty small).`,name:"timestep_scaling"},{anchor:"diffusers.LCMScheduler.rescale_betas_zero_snr",description:`<strong>rescale_betas_zero_snr</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to rescale the betas to have zero terminal SNR. This enables the model to generate very bright and
dark samples instead of limiting it to samples with medium brightness. Loosely related to
<a href="https://github.com/huggingface/diffusers/blob/74fd735eb073eb1d774b1ab4154a0876eb82f055/examples/dreambooth/train_dreambooth.py#L506" rel="nofollow"><code>--offset_noise</code></a>.`,name:"rescale_betas_zero_snr"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_lcm.py#L134"}}),w=new R({props:{name:"scale_model_input",anchor:"diffusers.LCMScheduler.scale_model_input",parameters:[{name:"sample",val:": Tensor"},{name:"timestep",val:": Optional = None"}],parametersDescription:[{anchor:"diffusers.LCMScheduler.scale_model_input.sample",description:`<strong>sample</strong> (<code>torch.Tensor</code>) &#x2014;
The input sample.`,name:"sample"},{anchor:"diffusers.LCMScheduler.scale_model_input.timestep",description:`<strong>timestep</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The current timestep in the diffusion chain.`,name:"timestep"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_lcm.py#L299",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>A scaled input sample.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>torch.Tensor</code></p>
`}}),T=new R({props:{name:"set_begin_index",anchor:"diffusers.LCMScheduler.set_begin_index",parameters:[{name:"begin_index",val:": int = 0"}],parametersDescription:[{anchor:"diffusers.LCMScheduler.set_begin_index.begin_index",description:`<strong>begin_index</strong> (<code>int</code>) &#x2014;
The begin index for the scheduler.`,name:"begin_index"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_lcm.py#L289"}}),D=new R({props:{name:"set_timesteps",anchor:"diffusers.LCMScheduler.set_timesteps",parameters:[{name:"num_inference_steps",val:": Optional = None"},{name:"device",val:": Union = None"},{name:"original_inference_steps",val:": Optional = None"},{name:"timesteps",val:": Optional = None"},{name:"strength",val:": int = 1.0"}],parametersDescription:[{anchor:"diffusers.LCMScheduler.set_timesteps.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The number of diffusion steps used when generating samples with a pre-trained model. If used,
<code>timesteps</code> must be <code>None</code>.`,name:"num_inference_steps"},{anchor:"diffusers.LCMScheduler.set_timesteps.device",description:`<strong>device</strong> (<code>str</code> or <code>torch.device</code>, <em>optional</em>) &#x2014;
The device to which the timesteps should be moved to. If <code>None</code>, the timesteps are not moved.`,name:"device"},{anchor:"diffusers.LCMScheduler.set_timesteps.original_inference_steps",description:`<strong>original_inference_steps</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The original number of inference steps, which will be used to generate a linearly-spaced timestep
schedule (which is different from the standard <code>diffusers</code> implementation). We will then take
<code>num_inference_steps</code> timesteps from this schedule, evenly spaced in terms of indices, and use that as
our final timestep schedule. If not set, this will default to the <code>original_inference_steps</code> attribute.`,name:"original_inference_steps"},{anchor:"diffusers.LCMScheduler.set_timesteps.timesteps",description:`<strong>timesteps</strong> (<code>List[int]</code>, <em>optional</em>) &#x2014;
Custom timesteps used to support arbitrary spacing between timesteps. If <code>None</code>, then the default
timestep spacing strategy of equal spacing between timesteps on the training/distillation timestep
schedule is used. If <code>timesteps</code> is passed, <code>num_inference_steps</code> must be <code>None</code>.`,name:"timesteps"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_lcm.py#L349"}}),P=new R({props:{name:"step",anchor:"diffusers.LCMScheduler.step",parameters:[{name:"model_output",val:": Tensor"},{name:"timestep",val:": int"},{name:"sample",val:": Tensor"},{name:"generator",val:": Optional = None"},{name:"return_dict",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.LCMScheduler.step.model_output",description:`<strong>model_output</strong> (<code>torch.Tensor</code>) &#x2014;
The direct output from learned diffusion model.`,name:"model_output"},{anchor:"diffusers.LCMScheduler.step.timestep",description:`<strong>timestep</strong> (<code>float</code>) &#x2014;
The current discrete timestep in the diffusion chain.`,name:"timestep"},{anchor:"diffusers.LCMScheduler.step.sample",description:`<strong>sample</strong> (<code>torch.Tensor</code>) &#x2014;
A current instance of a sample created by the diffusion process.`,name:"sample"},{anchor:"diffusers.LCMScheduler.step.generator",description:`<strong>generator</strong> (<code>torch.Generator</code>, <em>optional</em>) &#x2014;
A random number generator.`,name:"generator"},{anchor:"diffusers.LCMScheduler.step.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <code>LCMSchedulerOutput</code> or <code>tuple</code>.`,name:"return_dict"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/schedulers/scheduling_lcm.py#L498",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>If return_dict is <code>True</code>, <code>LCMSchedulerOutput</code> is returned, otherwise a
tuple is returned where the first element is the sample tensor.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>~schedulers.scheduling_utils.LCMSchedulerOutput</code> or <code>tuple</code></p>
`}}),I=new Te({props:{source:"https://github.com/huggingface/diffusers/blob/main/docs/source/en/api/schedulers/lcm.md"}}),{c(){p=a("meta"),U=r(),A=a("p"),G=r(),u(C.$$.fragment),j=r(),u(M.$$.fragment),J=r(),y=a("p"),y.innerHTML=he,Y=r(),u(L.$$.fragment),Z=r(),s=a("div"),u(S.$$.fragment),se=r(),H=a("p"),H.innerHTML=ge,oe=r(),O=a("p"),O.innerHTML=_e,re=r(),b=a("div"),u(w.$$.fragment),ie=r(),k=a("p"),k.textContent=be,ae=r(),v=a("div"),u(T.$$.fragment),de=r(),V=a("p"),V.textContent=ve,ce=r(),x=a("div"),u(D.$$.fragment),le=r(),z=a("p"),z.textContent=xe,pe=r(),$=a("div"),u(P.$$.fragment),ue=r(),F=a("p"),F.textContent=$e,B=r(),u(I.$$.fragment),K=r(),W=a("p"),this.h()},l(e){const o=we("svelte-u9bgzb",document.head);p=d(o,"META",{name:!0,content:!0}),o.forEach(t),U=i(e),A=d(e,"P",{}),E(A).forEach(t),G=i(e),m(C.$$.fragment,e),j=i(e),m(M.$$.fragment,e),J=i(e),y=d(e,"P",{"data-svelte-h":!0}),N(y)!=="svelte-1hnnbn8"&&(y.innerHTML=he),Y=i(e),m(L.$$.fragment,e),Z=i(e),s=d(e,"DIV",{class:!0});var c=E(s);m(S.$$.fragment,c),se=i(c),H=d(c,"P",{"data-svelte-h":!0}),N(H)!=="svelte-1cn3gww"&&(H.innerHTML=ge),oe=i(c),O=d(c,"P",{"data-svelte-h":!0}),N(O)!=="svelte-1cd4ofg"&&(O.innerHTML=_e),re=i(c),b=d(c,"DIV",{class:!0});var X=E(b);m(w.$$.fragment,X),ie=i(X),k=d(X,"P",{"data-svelte-h":!0}),N(k)!=="svelte-1rkfgpx"&&(k.textContent=be),X.forEach(t),ae=i(c),v=d(c,"DIV",{class:!0});var ee=E(v);m(T.$$.fragment,ee),de=i(ee),V=d(ee,"P",{"data-svelte-h":!0}),N(V)!=="svelte-1k141rk"&&(V.textContent=ve),ee.forEach(t),ce=i(c),x=d(c,"DIV",{class:!0});var te=E(x);m(D.$$.fragment,te),le=i(te),z=d(te,"P",{"data-svelte-h":!0}),N(z)!=="svelte-1vzm9q"&&(z.textContent=xe),te.forEach(t),pe=i(c),$=d(c,"DIV",{class:!0});var ne=E($);m(P.$$.fragment,ne),ue=i(ne),F=d(ne,"P",{"data-svelte-h":!0}),N(F)!=="svelte-hi84tp"&&(F.textContent=$e),ne.forEach(t),c.forEach(t),B=i(e),m(I.$$.fragment,e),K=i(e),W=d(e,"P",{}),E(W).forEach(t),this.h()},h(){q(p,"name","hf:doc:metadata"),q(p,"content",Pe),q(b,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),q(v,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),q(x,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),q($,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),q(s,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,o){n(document.head,p),l(e,U,o),l(e,A,o),l(e,G,o),f(C,e,o),l(e,j,o),f(M,e,o),l(e,J,o),l(e,y,o),l(e,Y,o),f(L,e,o),l(e,Z,o),l(e,s,o),f(S,s,null),n(s,se),n(s,H),n(s,oe),n(s,O),n(s,re),n(s,b),f(w,b,null),n(b,ie),n(b,k),n(s,ae),n(s,v),f(T,v,null),n(v,de),n(v,V),n(s,ce),n(s,x),f(D,x,null),n(x,le),n(x,z),n(s,pe),n(s,$),f(P,$,null),n($,ue),n($,F),l(e,B,o),f(I,e,o),l(e,K,o),l(e,W,o),Q=!0},p:Me,i(e){Q||(h(C.$$.fragment,e),h(M.$$.fragment,e),h(L.$$.fragment,e),h(S.$$.fragment,e),h(w.$$.fragment,e),h(T.$$.fragment,e),h(D.$$.fragment,e),h(P.$$.fragment,e),h(I.$$.fragment,e),Q=!0)},o(e){g(C.$$.fragment,e),g(M.$$.fragment,e),g(L.$$.fragment,e),g(S.$$.fragment,e),g(w.$$.fragment,e),g(T.$$.fragment,e),g(D.$$.fragment,e),g(P.$$.fragment,e),g(I.$$.fragment,e),Q=!1},d(e){e&&(t(U),t(A),t(G),t(j),t(J),t(y),t(Y),t(Z),t(s),t(B),t(K),t(W)),t(p),_(C,e),_(M,e),_(L,e),_(S),_(w),_(T),_(D),_(P),_(I,e)}}}const Pe='{"title":"Latent Consistency Model Multistep Scheduler","local":"latent-consistency-model-multistep-scheduler","sections":[{"title":"Overview","local":"overview","sections":[],"depth":2},{"title":"LCMScheduler","local":"diffusers.LCMScheduler","sections":[],"depth":2}],"depth":1}';function Ie(fe){return ye(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Oe extends Le{constructor(p){super(),Se(this,p,Ie,De,Ce,{})}}export{Oe as component};
